<template>
  <div
    v-if="contacts && contacts.length"
    class="sclContacts"
    :class="sizeIcon">
    <a
      v-if="getContact(ref.ContactTypes.ICQ)"
      class="sclContacts-item"
      target="_blank"
      rel="nofollow"
      :href="getContact(ref.ContactTypes.ICQ).href"
      @click="$ym('messanger_icq'); clicked();"
      v-tooltip="{ classes: popoverBaseClass, trigger: 'hover', placement: 'bottom', content: 'ICQ' }">
      <img
        svg-inline
        src="~/assets/svg/redesign/social-icq.svg"
        alt="">
    </a>
    <a
      v-if="getContact(ref.ContactTypes.TELEGRAM)"
      class="sclContacts-item"
      target="_blank"
      rel="nofollow"
      :href="getContact(ref.ContactTypes.TELEGRAM).href"
      @click="$ym('messanger_telegram'); clicked();"
      v-tooltip="{ classes: popoverBaseClass, trigger: 'hover', placement: 'bottom', content: 'Telegram' }">
      <img
        svg-inline
        src="~/assets/svg/redesign/social-telegram.svg">
    </a>
    <a
      v-if="getContact(ref.ContactTypes.VIBER)"
      class="sclContacts-item"
      target="_blank"
      rel="nofollow"
      :href="getContact(ref.ContactTypes.VIBER).href"
      @click="$ym('messanger_viber'); clicked();"
      v-tooltip="{ classes: popoverBaseClass, trigger: 'hover', placement: 'bottom', content: 'Viber' }">
      <img
        svg-inline
        src="~/assets/svg/redesign/social-viber.svg">
    </a>
    <a
      v-if="getContact(ref.ContactTypes.WHATSAPP)"
      class="sclContacts-item"
      target="_blank"
      rel="nofollow"
      :href="getContact(ref.ContactTypes.WHATSAPP).href"
      @click="$ym('messanger_whatsapp'); clicked();"
      v-tooltip="{ classes: popoverBaseClass, trigger: 'hover', placement: 'bottom', content: 'Whatsapp' }">
      <img
        svg-inline
        src="~/assets/svg/redesign/social-whatsapp.svg">
    </a>
    <a
      v-if="getContact(ref.ContactTypes.SKYPE)"
      class="sclContacts-item"
      target="_blank"
      rel="nofollow"
      :href="getContact(ref.ContactTypes.SKYPE).href"
      @click="$ym('messanger_skype'); clicked();"
      v-tooltip="{ classes: popoverBaseClass, trigger: 'hover', placement: 'bottom', content: 'Skype' }">
      <img
        svg-inline
        src="~/assets/svg/redesign/social-skype.svg">
    </a>
  </div>
</template>

<script>
import ContactTypes from '~/assets/js/enums/shop-additional-contacts';

export default {
  name: 'AppSocial',
  props: {
    sizeIcon: {
      type: String,
      default: '',
    },
    contacts: {
      type: Array,
      default() {
        return [];
      },
    },
  },
  data() {
    return {
      popoverBaseClass: 'tooltip tooltipDark',
      ref: {
        ContactTypes,
      },
    };
  },
  methods: {
    clicked() {
      this.$emit('clicked');
    },
    getContact(typeId) {
      const contact = this.contacts.find(contactItem => Number(contactItem.type_id) === Number(typeId));
      if (!contact) {
        return false;
      }
      let href = '';
      switch (contact.type_id) {
        case this.ref.ContactTypes.SKYPE:
          href = `skype:${contact.value}?chat`;
          break;
        case this.ref.ContactTypes.ICQ:
          href = `http://www.icq.com/people/${contact.value}`;
          break;
        case this.ref.ContactTypes.TELEGRAM:
          href = `tg://resolve?domain=${contact.value}`;
          break;
        case this.ref.ContactTypes.WHATSAPP:
          href = `https://wa.me/${contact.value.replace(/\D/g, '')}`;
          break;
        case this.ref.ContactTypes.VIBER:
          href = `viber://chat?number=${contact.value.replace(/\D/g, '')}`;
          break;
        default:
          return false;
      }
      return {
        ...contact,
        href,
      };
    },
  },
};
</script>

<style lang="postcss">
  .sclContacts {
    display: flex;
    align-items: center;

    &-item {
      display: inline-flex;
      flex-shrink: 0;

      .svg {
        display: block;
        width: 100%;
        height: 100%;
        margin: auto;
      }
    }

    &._entity-offer {
      margin-left: 0.125rem;

      .sclContacts-item {
        margin-right: 0;
      }
    }

    @media screen and (min-width: 981px) {
      &-item {
        margin: 0 0.25rem;
        width: 1.75rem;
        height: 1.75rem;

        &:first-of-type {
          margin-left: 0;
        }
        &:last-of-type {
          margin-right: 0;
        }
      }
    }

    @media (min-width: 981px) and (max-width: 1200px) {
      &-item {
        width: 2.375rem;
        height: 2.375rem;
      }
    }
    @media screen and (max-width: 980px) {
      flex-wrap: wrap;
      margin-left: -0.5rem;
      margin-right: -0.5rem;

      &-item {
        width: 3.75rem;
        height: 3.75rem;
        margin: 0 0.5rem 0.5rem;
      }
    }
  }
</style>
